// BEGIN: FUNCTION RESIZE WINDOW
if (!expresso_offline) {
	var _showBar = showBar;
	var _hideBar = hideBar;
}

function __showBar(){
	_showBar();
	resizeWindow();
}

function __hideBar(){
	_hideBar();
	resizeWindow();
}
showBar = __showBar;
hideBar = __hideBar;

window.onresize = resizeWindow;

function config_events(pObj, pEvent, pHandler)
{
    if( typeof pObj == 'object')
    {
        if( pEvent.substring(0, 2) == 'on')
            pEvent = pEvent.substring(2, pEvent.length);

        if ( pObj.addEventListener )
            pObj.addEventListener(pEvent, pHandler, false);
        else if( pObj.attachEvent )
            pObj.attachEvent('on' + pEvent, pHandler );
    }
}

function resizeWindow(){

	var divScrollMain = Element("divScrollMain_"+numBox); 
	var table_message = Element("table_message"); 
	var content_folders = Element("content_folders"); 
	var clientHeight = ((window.innerHeight ? window.innerHeight : document.body.offsetHeight) - 8); 
	var clientWidth = window.innerWidth ? window.innerWidth : document.body.offsetWidth;

	if(divScrollMain){ 
		divScrollMain.style.height = (clientHeight - (findPosY(divScrollMain) + (table_message.clientHeight ? table_message.clientHeight : table_message.offsetHeight))) + "px"; 
	} 

	if(typeof(BordersArray) != 'undefined') {
		for(var i = 1; BordersArray.length > 1 && i < BordersArray.length;i++) {
			var div_scroll = Element("div_message_scroll_"+BordersArray[i].sequence);
			var div = Element("content_id_"+BordersArray[i].sequence);

			if(div){ 
				div.style.height = (clientHeight - (findPosY(div) + (table_message.clientHeight ? table_message.clientHeight : table_message.offsetHeight)+2)) + "px"; 
				 div.style.width = (clientWidth - (findPosX(div)+10)) + "px"; 
			} 
			if(div_scroll){ 
				div_scroll.style.height = (clientHeight - (findPosY(div_scroll) + (table_message.clientHeight ? table_message.clientHeight : table_message.offsetHeight)+5)) + "px"; 
				div_scroll.style.width = (clientWidth - (findPosX(div_scroll)+15)) + "px"; 
			} 
		} 
	} 

	if(content_folders){ 
		var search_div = Element("search_div"); 
		var contentFoldersY = findPosY(content_folders); 
		content_folders.style.height = (clientHeight - (contentFoldersY + (contentFoldersY > findPosY(search_div) ? 0 : (search_div.clientHeight ? search_div.clientHeight : search_div.offsetHeight) + 5))) + "px"; 
	} 
}
// END: FUNCTION RESIZE WINDOW

var _beforeunload_ = window.onbeforeunload;

window.onbeforeunload = function()
{
	return unloadMess();
}

function unloadMess(){
	if (typeof(expresso_mail_sync) != "undefined" && expresso_mail_sync.working) {
		var mess = get_lang("You're about archiving your e-mails from server. Do you really want to stop this action?");
		return mess;
	}
	else {
		var mess = get_lang("Your message has not been sent and will be discarted.");
		for (var i = 0; i < BordersArray.length; i++) {
			var body = Element('body_' + BordersArray[i].sequence);
			if (body && body.contentWindow && body.contentWindow.document.designMode.toLowerCase() == 'on') {
				return mess;
			}
		}
	}
}

// Translate words and phrases using user language from eGroupware.
function get_lang(_key) {
	if (typeof(_key) == 'undefined') 
		return false; 
	var key = _key.toLowerCase();
	if(array_lang[key])
		var _value = array_lang[key];
	else
		var _value = _key+"*";

	if(arguments.length > 1)
		for(j = 1; typeof(arguments[j]) != 'undefined'; j++)
			_value = _value.replace("%"+j,arguments[j]);
	return _value;
}

// Make decimal round, using in size message
function round(value, decimal){
	var return_value = Math.round( value * Math.pow( 10 , decimal ) ) / Math.pow( 10 , decimal );
	return( return_value );
}

// Change the class of message.
// In refresh, the flags UnRead and UnSeen don't exist anymore. 
function set_msg_as_read(msg_number, selected){
	tr_message = Element(msg_number);
	if (exist_className(tr_message, 'tr_msg_unread'))
		decrement_folder_unseen();
	remove_className(tr_message, 'tr_msg_unread');
	remove_className(tr_message, 'selected_msg');
	Element("td_message_unseen_"+msg_number).innerHTML = "<img src ='templates/"+template+"/images/seen.gif' title='"+get_lang('Seen')+"'>"; 
	connector.purgeCache();
	return true;
}

function msg_is_read(msg_number, selected){
	tr_message = Element(msg_number);
	return !(tr_message && LTrim(tr_message.className).match('tr_msg_unread'))
}

function set_msg_as_unread(msg_number){
	tr_message = Element(msg_number);
	if ((exist_className(tr_message, 'tr_msg_read') || exist_className(tr_message, 'tr_msg_read2')) && (!exist_className(tr_message, 'tr_msg_unread')))
		increment_folder_unseen();	
	remove_className(tr_message, 'selected_msg');
	add_className(tr_message, 'tr_msg_unread');
	Element("td_message_unseen_"+msg_number).innerHTML = "<img src ='templates/"+template+"/images/unseen.gif' title='"+get_lang('Unseen')+"'>"; 
}

function set_msg_as_flagged(msg_number){
	var msg = Element(msg_number);
	remove_className(msg, 'selected_msg');
	add_className(msg, 'flagged_msg');
	Element("td_message_important_"+msg_number).innerHTML = "<img src ='templates/"+template+"/images/important.gif' title='"+get_lang('Important')+"'>";
}

function set_msg_as_unflagged(msg_number){
	var msg = Element(msg_number);
	remove_className(msg, 'selected_msg');
	remove_className(msg, 'flagged_msg');
	Element("td_message_important_"+msg_number).innerHTML = "&nbsp;&nbsp;&nbsp;";
}

function removeAll(id){
	do
	{
		if (typeof(Element(id)) == 'undefined')
			break;
		Element(id).parentNode.removeChild(Element(id));
	}
	while(Element(id));
}

function get_current_folder(){
	return current_folder;
}

// Kill current box (folder or page).
function kill_current_box(){
	var box = document.getElementById("table_box");
	if (box != null)
		box.parentNode.removeChild(box);
	else
		return false;
}

// Kill current paging.
function kill_current_paging(){
	var paging = Element("span_paging");
	if (paging != null)
		paging.parentNode.removeChild(paging);
}

function show_hide_span_paging(ID){
	if (Element("span_paging"+ID))
		Element("span_paging"+ID).style.display = '';
	if (Element("span_paging"+currentTab))
		Element("span_paging"+currentTab).style.display = 'none';
}

//Get the current number of messages in a page.
function get_messages_number_in_page(){
	//Get element tBody.
	main = document.getElementById("tbody_box");
		
	// Get all TR (messages) in tBody.
	main_list = main.childNodes;
	
	return main_list.length;
}

function download_local_attachment(url) {
	url=encodeURI(url);
	url=url.replace("%25","%");
	if (div_attachment == null){
		var div_attachment = document.createElement("DIV");
		div_attachment.id="id_div_attachment";
		document.body.appendChild(div_attachment);
	}
	div_attachment.innerHTML="<iframe style='display:none;width:0;height:0' name='attachment' src='"+url+"'></iframe>";
}

function download_attachments(msg_folder, msg_number, idx_file, msg_part, encoding, new_file_name, show_iframe){
	div_attachment = document.getElementById("id_div_attachment");
	var params = '';
	
	if (div_attachment == null){
		var div_attachment = document.createElement("DIV");
		div_attachment.id="id_div_attachment";
		document.body.appendChild(div_attachment);
	}
	if(new_file_name)
		params = "&newfilename="+escape(new_file_name);
	if(encoding)
		params += "&encoding="+encoding;

	div_attachment.innerHTML="<iframe style='display:none;width:0;height:0' name='attachment' src='inc/gotodownload.php?msg_folder="+msg_folder+"&msg_number="+msg_number+"&idx_file="+idx_file+"&msg_part="+msg_part+params+"'></iframe>";
}

function download_all_attachments(msg_folder, msg_number){
	var handler_source = function(data){		
		download_attachments(null, null, data, null,null,'anexos.zip');
	}
	cExecute("$this.exporteml.download_all_attachments",handler_source,"folder="+msg_folder+"&num_msg="+msg_number);
}
//ADD forwarded files
function addForwardedFile(id_border,file_name,link){
	divFiles = document.getElementById("divFiles_"+id_border);

	if (! divFiles)
		return false;
	
	if (divFiles.lastChild)
		var countDivFiles = parseInt(divFiles.lastChild.id.split('_')[2]) + 1;

	if (! countDivFiles)
		var countDivFiles = 1;
	
	divFile = document.createElement('DIV');
	

	if (!expresso_offline) {
		if (!is_ie) {
			var inputFile = document.createElement("INPUT");
			
			var tmp_id_border = document.createAttribute('id_border');
			tmp_id_border.value = id_border;
			
			inputFile.setAttributeNode(tmp_id_border);
			inputFile.id = "inputFile_" + id_border + "_" + countDivFiles;
			inputFile.type = 'file';
			inputFile.size = 50;
			inputFile.maxLength = 255;
			inputFile.name = 'file_' + countDivFiles;
			inputFile.style.display = "none";
		}
		else {
			var inputFile = document.createElement("link");
			
			var tmp_id_border = document.createAttribute('id_border');
			tmp_id_border.value = id_border;
			
			inputFile.setAttributeNode(tmp_id_border);
			inputFile.id = "inputFile_" + id_border + "_" + countDivFiles;
			inputFile.name = 'file_' + countDivFiles;
			
			
		}
		
	}
	else {
		var inputFile = document.createElement("input");
		inputFile.type = 'hidden';
		inputFile.name = 'offline_forward_' + countDivFiles;
	}	
	divFile.appendChild(inputFile);

	var a_tmp = new Array();
	a_tmp[0] = "local_";
	a_tmp[1] = 'file_' + countDivFiles;
	a_tmp[2] = file_name;
	s_tmp = escape(connector.serialize(a_tmp));
	var checkbox = document.createElement("INPUT");
	checkbox.type = "checkbox";
	checkbox.id = "checkbox_"+id_border+"_"+countDivFiles;
	checkbox.name = "local_attachments[]";
	
	checkbox.value = s_tmp;
	divFile.appendChild(checkbox);
	
	var link_attachment = document.createElement("A");
	link_attachment.setAttribute("href", link);
	
	link_attachment.innerHTML = file_name;
	divFile.appendChild(link_attachment);
	
	countDivFiles++;
	divFile.id = "divFile_"+id_border+"_"+countDivFiles;	
	divFiles.appendChild(divFile);

	checkbox.checked = true; //Incrível, mas no Internet Explorer o checked só funciona efetivamente se o elemente já estiver renderizado... por isso só aqui eu seleciono ele...
	return inputFile;
}

// Add Input File Dynamically.
function addFile(id_border){
	divFiles = document.getElementById("divFiles_"+id_border);
	if (! divFiles)
		return false;
	
	if (divFiles.lastChild)
		var countDivFiles = parseInt(divFiles.lastChild.id.split('_')[2]) + 1;

	if (! countDivFiles)
		var countDivFiles = 1;
	
	divFile = document.createElement('DIV');
	
	
	divFile.innerHTML = "<input type='file' id_border='"+id_border+"' size='50' maxLength='255' onchange=\"function () {validateFileExtension(this.value, this.id.replace('input','div'), this.getAttribute('id_border'));};\" id='"+"inputFile_"+id_border+"_"+countDivFiles+"' name='file_"+countDivFiles+"'>";

	
	var linkFile = document.createElement("A");
	linkFile.id = "linkFile_"+id_border+"_"+countDivFiles;
	linkFile.href='javascript:void(0)';
	linkFile.onclick=function () {removeFile(this.id.replace("link","div")); return false;};
	linkFile.innerHTML=get_lang("Remove");	
	//divFile.innerHTML += "&nbsp;&nbsp;";
	divFile.appendChild(linkFile);
	divFile.id = "divFile_"+id_border+"_"+countDivFiles;	
	divFiles.appendChild(divFile);

	

	return document.getElementById("inputFile_"+id_border+"_"+countDivFiles);
}
//	Remove Input File Dynamically.
function removeFile(id){
	var border_id = id.substr(8,1);
	var el = Element(id);
	el.parentNode.removeChild(el);
}

function validateFileExtension(fileName, id, id_border){
	
	var error_flag  = false;

	if ( fileName.indexOf('/') != -1 )
	{
		if (fileName[0] != '/'){ // file name is windows format?
			var file = fileName.substr(fileName.lastIndexOf('\\') + 1, fileName.length);
			if ((fileName.indexOf(':\\') != 1) && (fileName.indexOf('\\\\') != 0)) // Is stored in partition or a network file?
				error_flag = true;	
		}
		else // is Unix
			var file = fileName.substr(fileName.lastIndexOf('/') + 1, fileName.length);						
	}
	else  // is Firefox 3
		var file = fileName;

	var fileExtension = file.split(".");
	fileExtension = fileExtension[(fileExtension.length-1)];
	for(var i=0; i<denyFileExtensions.length; i++)
	{
		if(denyFileExtensions[i] == fileExtension)
		{
			error_flag = true;
			break;
		}
			
	}

	if ( error_flag == true )
	{
		alert(get_lang('File extension forbidden or invalid file') + '.');
		removeFile(id);
		addFile(id_border);
		return false;
	}
	return true;
}

var setTimeout_write_msg = 0;
var old_msg = false;
// Funcao usada para escrever mensagem
// notimeout = True : mensagem nao apaga
function write_msg(msg, notimeout){	
	
	if (setTimeout_write_msg)
		clearTimeout(setTimeout_write_msg);
	
	var msg_div = Element('em_div_write_msg');
	var old_divStatusBar = Element("divStatusBar");

	if(!msg_div) {
		msg_div = document.createElement('DIV');
		msg_div.id = 'em_div_write_msg';
		msg_div.className = 'em_div_write_msg';
		old_divStatusBar.parentNode.insertBefore(msg_div,old_divStatusBar);
	}
	
	if( document.getElementById('JabberMessenger'))
		loadscript.adIcon();

	msg_div.innerHTML = '<table width="100%" cellspacing="0" cellpadding="0" border="0"><tbody><tr><th width="40%"></th><th noWrap class="action_info_th">'+msg+'</th><th width="40%"></th></tr></tbody></table>';

	old_divStatusBar.style.display = 'none';
	msg_div.style.display = '';	
	// Nao ponha var na frente!! jakjr
	handle_write_msg = function(){
		try{
			if(!old_msg)
				clean_msg();
			else
				write_msg(old_msg, true);			
		}
		catch(e){}
	}
	if(notimeout)
		old_msg = msg;
	else
		setTimeout_write_msg = setTimeout("handle_write_msg();", 5000);
}
// Funcao usada para apagar mensagem sem timeout
function clean_msg(){
	old_msg = false;
	var msg_div = Element('em_div_write_msg');
	var old_divStatusBar = Element("divStatusBar");
	if(msg_div)
		msg_div.style.display = 'none';
	old_divStatusBar.style.display = '';	
}

function make_body_reply(body, to, date_day, date_hour){
	to = to.replace("<","&lt;");
	to = to.replace(">","&gt;");
	block_quoted_body ="<br><br>";
	block_quoted_body += get_lang('At %1, %2 hours, %3 wrote:', date_day, date_hour, to);
	block_quoted_body += "<blockquote style=\"border-left: 1px solid rgb(204, 204, 204); margin: 0pt 0pt 0pt 0.8ex; padding-left: 1ex;\">";
	block_quoted_body += body;
	block_quoted_body += "</blockquote>";
	return block_quoted_body;
}

function make_forward_body(body, from, date, subject, to, cc){
	from = from.replace(/</g,"&lt;");
	from = from.replace(/>/g,"&gt;");
	to = to.replace(/</g,"&lt;");
	to = to.replace(/>/g,"&gt;");
	var forward_body = '<BR><BR>---------- ' + get_lang('Forwarded message') + ' ----------<BR>';
	forward_body += get_lang('From') + ': ' + from + '<BR>';
	forward_body += get_lang('Date') + ': ' + date + '<BR>';
	forward_body += get_lang('Subject') + ': ' + subject + '<BR>';
	forward_body += get_lang('To') + ': ' + to+ '<BR>';
	if(cc != undefined){
		cc = cc.replace(/</g,"&lt;");
		cc = cc.replace(/>/g,"&gt;");
		forward_body += get_lang('CC') + ': ' + cc+ '<BR><BR>';
	}
	forward_body += body;
	return forward_body;
}

function emMessageSearch(e,value){
	var	e  = is_ie ? window.event : e;
	if(e.keyCode == 13) {
		search_emails(value);
	}
}

function validateEmail(email){
	if (typeof(email) != 'string')
		return false;
	var validName = /^[a-z][a-z-_0-9\.]*/i;
	emailParts = email.split('@');
	return (validName.test(emailParts[0]) && validateDomain(emailParts[1]));
}
function validateDomain(domain){
	var domainReg = /^(([A-Za-z\d][A-Za-z\d-]{0,61}[A-Za-z\d]\.)+[A-Za-z]{2,6}|\[\d{1,3}(\.\d{1,3}){3}\])$/i;
	return (domainReg.test(domain));
}

function validateUrl(url){
	var urlReg = /([A-Za-z]{2,7}:\/\/)(.*)/i;
	urlParts = url.split(urlReg);
	return (urlParts[1].length > 4 &&  validateDomain(urlParts[2]));
}
function emQuickSearch(emailList, field, ID){
	var quickSearchKeyBegin;
	var quickSearchKeyEnd;
	if(expresso_offline) {
		alert(get_lang('Not allowed in offline mode'));
		return;
	}
		
	var handler_emQuickSearch = function(data)
	{
		window_DropDownContacts = Element('tipDiv');
		if (window_DropDownContacts.style.visibility != 'hidden'){
			window_DropDownContacts.style.visibility = 'hidden';
		}
		
		if ((!data.status) && (data.error == "many results")){
			alert(get_lang('More than %1 results. Please, try to refine your search.',200));
			return false;
		}
			
		if (data.length > 0){
			if ((field != 'null') && (ID != 'null'))
			{
				connector.loadScript("QuickCatalogSearch");
				if (typeof(QuickCatalogSearch) == 'undefined'){
					setTimeout('emQuickSearch("'+emailList+'", "'+field+'", "'+ID+'")',500);
					return false;
				}
				QuickCatalogSearch.showList(data, quickSearchKeyBegin, quickSearchKeyEnd);
			}
			else
			{
				connector.loadScript("QuickSearchUser");
				if (typeof(QuickSearchUser) == 'undefined'){
					setTimeout('emQuickSearch("'+emailList+'", "'+field+'", "'+ID+'")',500);
					return false;
				}
				QuickSearchUser.showList(data);
			}
		}
		else
			alert(get_lang('None result was found.'));
		return true;
	}
	
	if ((field != 'null') && (ID != 'null'))
	{
		Element(field +'_'+ ID).focus(); //It requires for IE.
		var i = getPosition(Element(field +'_'+ ID)); //inputBox.selectionStart;
		var j = --i;

		// Acha o inicio
    	while ((j >= 0) && (emailList.charAt(j) != ',')){j--};
	    quickSearchKeyBegin = ++j;

	    // Acha o final
    	while ((i <= emailList.length) && (emailList.charAt(i) != ',')){i++};
	    quickSearchKeyEnd = i;

	    // A Chave da Pesquisa
    	var search_for = trim(emailList.substring(quickSearchKeyBegin, quickSearchKeyEnd));
	}
	else
		var search_for = emailList;
	
	if (search_for.length < preferences.search_characters_number){
            alert(get_lang('Your search argument must be longer than %1 characters.', preferences.search_characters_number));
            return false;
	}
	
	cExecute ("$this.ldap_functions.quicksearch&search_for="+search_for+"&field="+field+"&ID="+ID, handler_emQuickSearch);
}

function folderbox(){
	connector.loadScript("TreeS");
	if (typeof(ttree) == 'undefined'){
		setTimeout('folderbox()',500);
		return false;
	}
	ttree.make_Window();
}

function filterbox(){
	connector.loadScript("filter");
	connector.loadScript("filters");
	if (typeof(filters) == 'undefined')
	{
		 setTimeout('filterbox()',500);
	         return false;
	}
	filters.Forms();
}

function sharebox(){
	var handler_imap_getacl = function(data)
	{
		var options = '';
		for (var x in data)
		{
			options += "<option value='"+data[x].uid+"'>"+data[x].cn+"</option>";
		}
		connector.loadScript("sharemailbox");
		if (typeof(sharemailbox) == 'undefined')
		{
			setTimeout('sharebox()',500);
			return false;
		}
		sharemailbox.makeWindow(options);
	}
	cExecute ("$this.imap_functions.getacl", handler_imap_getacl);
}

function open_rss(param){
	connector.loadScript("news_edit");
	if (typeof(news_edit) == 'undefined')
	{
		setTimeout('open_rss(\''+param+'\')',500);
		return false;
	}
	news_edit.read_rss(param);
	return true;
}

function editrss(){
	connector.loadScript("news_edit");
	if (typeof(news_edit) == 'undefined')
	{
		setTimeout('editrss()',500);
		return false;
	}
	news_edit.makeWindow();
}




function preferences_mail(){
	location.href="../preferences/preferences.php?appname=expressoMail1_2";
}

function search_emails(value){
	connector.loadScript("TreeS");
	connector.loadScript("search");
	if (typeof(EsearchE) == 'undefined' || typeof(ttree) == 'undefined'){
		setTimeout('search_emails("'+value+'")',500);
		return false;
	}
	EsearchE.showForms(value);
}

function source_msg(id_msg,folder){
	var num_msg = id_msg.substr(0,(id_msg.length - 2));
	var handler_source = function(data){
		download_attachments(null, null, data, null,null,'fonte_da_mensagem.eml');
	}
	cExecute("$this.exporteml.export_msg",handler_source,"folder="+url_decode(folder)+"&msgs_to_export="+num_msg);
}

function url_encode(str){
    var hex_chars = "0123456789ABCDEF";
    var noEncode = /^([a-zA-Z0-9\_\-\.])$/;
    var n, strCode, hex1, hex2, strEncode = "";

    for(n = 0; n < str.length; n++) {
        if (noEncode.test(str.charAt(n))) {
            strEncode += str.charAt(n);
        } else {
            strCode = str.charCodeAt(n);
            hex1 = hex_chars.charAt(Math.floor(strCode / 16));
            hex2 = hex_chars.charAt(strCode % 16);
            strEncode += "%" + (hex1 + hex2);
        }
    }
    return strEncode;
}

function url_decode(str) {

	var n, strCode, strDecode = "";
	for (n = 0; n < str.length; n++) {
	    if (str.charAt(n) == "%") {
	        strCode = str.charAt(n + 1) + str.charAt(n + 2);
	        strDecode += String.fromCharCode(parseInt(strCode, 16));
	        n += 2;
	    } else {
	        strDecode += str.charAt(n);
	    }
	}
	return strDecode;
}

function Element (el) {
	return	document.getElementById(el);
}

function getPosition(obj)
{
	if(typeof obj.selectionStart != "undefined")
	{
    	return obj.selectionStart;
	}
	else if(document.selection && document.selection.createRange)
	{
		var M = document.selection.createRange();
		try
		{
			var Lp = M.duplicate();
			Lp.moveToElementText(obj);
		}
		catch(e)
		{
			var Lp=obj.createTextRange();
		}
		
		Lp.setEndPoint("EndToStart",M);
		var rb=Lp.text.length;
		
		if(rb > obj.value.length)
		{
			return -1;
		}
		return rb;
	}
}

function trim(inputString) {
   if (typeof inputString != "string") 
   	return inputString;
      
   var retValue = inputString;
   var ch = retValue.substring(0, 1);
   while (ch == " ") { 
	  retValue = retValue.substring(1, retValue.length);
	  ch = retValue.substring(0, 1);
   }
   ch = retValue.substring(retValue.length-1, retValue.length);
   while (ch == " ") { 
	  retValue = retValue.substring(0, retValue.length-1);
	  ch = retValue.substring(retValue.length-1, retValue.length);
   }
   while (retValue.indexOf("  ") != -1) { 
	  retValue = retValue.substring(0, retValue.indexOf("  ")) + retValue.substring(retValue.indexOf("  ")+1, retValue.length); 
   }
   return retValue; 
}

function increment_folder_unseen(){
	var folder_id = get_current_folder();

	var folder_unseen = Element('dftree_'+folder_id+'_unseen');
	var abas_unseen = Element('new_m').innerHTML;
        abas_unseen = abas_unseen.match( /[0-9]+/);

	if (folder_unseen)
	{
		folder_unseen.innerHTML = (parseInt(folder_unseen.innerHTML) + 1);
	}
	else
	{
		tree_folders.getNodeById(folder_id).alter({caption: tree_folders.getNodeById(current_folder).caption + '<font style=color:red>&nbsp(</font><span id="dftree_'+current_folder+'_unseen" style=color:red>1</span><font style=color:red>)</font>'});
		tree_folders.getNodeById(folder_id)._refresh();
	}
	if (abas_unseen)
	{
		abas_unseen = parseInt(abas_unseen) + 1;
		Element('new_m').innerHTML = '<font style="color:red">' + abas_unseen + '</font>';
	}
	else{
		abas_unseen = Element('new_m').innerHTML;
		abas_unseen = abas_unseen.match( /[0-9]+/);
		abas_unseen = parseInt(abas_unseen) + 1;
		Element('new_m').innerHTML = '<font style="color:red">' + abas_unseen + '</font>';
	}
	if ( current_folder.indexOf( 'INBOX' ) !== 0 && current_folder.indexOf( 'local_' ) !== 0 )
	{
		var display_unseen_in_shared_folders = Element('dftree_user_unseen');
		if ( display_unseen_in_shared_folders )
			tree_folders.getNodeById( 'user' ).alter({caption:'<font style=color:red>[</font><span id="dftree_user_unseen" style="color:red">' + ( parseInt( display_unseen_in_shared_folders.innerHTML) + 1 ) + '</span><font style=color:red>]</font>' + get_lang("Shared folders")});
		else
			tree_folders.getNodeById( 'user' ).alter({caption:'<font style=color:red>[</font><span id="dftree_user_unseen" style="color:red">1</span><font style=color:red>]</font>' + get_lang("Shared folders")});
		tree_folders.getNodeById( 'user' )._refresh();
	}
	var display_unseen_in_mailbox = Element('dftree_root_unseen');
	if(!expresso_offline)
		var node_to_refresh = 'root';
	else
		var node_to_refresh = 'local_root';
	tree_folders.getNodeById( node_to_refresh )._refresh();
}
function decrement_folder_unseen(){
	var folder_id = get_current_folder();

	var folder_unseen = Element('dftree_'+folder_id+'_unseen');
	var abas_unseen = Element('new_m').innerHTML;
        abas_unseen = abas_unseen.match( /[0-9]+/);

	if(!folder_unseen || !abas_unseen)
		return;

	if ((folder_unseen) && (parseInt(folder_unseen.innerHTML) > 1))
	{
		folder_unseen.innerHTML = (parseInt(folder_unseen.innerHTML) - 1);
	}
	else if (parseInt(folder_unseen.innerHTML) <= 1)
	{
		var tmp_folder_name = tree_folders.getNodeById(folder_id).caption.split('<');
		var folder_name = tmp_folder_name[0];
		tree_folders.getNodeById(folder_id).alter({caption: folder_name});
		tree_folders.getNodeById(folder_id)._refresh();
	}
	if ((abas_unseen) && (parseInt(abas_unseen) > 1))
        {
	        abas_unseen = (parseInt(abas_unseen) - 1);
	        Element('new_m').innerHTML = '<font style="color:red">' + abas_unseen + '</font>';
	}
	else if (parseInt(abas_unseen) <= 1)
	{
		Element('new_m').innerHTML = '0';
	}
	if ( current_folder.indexOf( 'INBOX' ) !== 0 )
	{
		var display_unseen_in_shared_folders = Element('dftree_user_unseen');
		if ( display_unseen_in_shared_folders )
		{
			var unseen_in_shared_folders = parseInt( display_unseen_in_shared_folders.innerHTML );
			unseen_in_shared_folders--;
			if ( unseen_in_shared_folders > 0 )
				tree_folders.getNodeById( 'user' ).alter({caption:'<font style=color:red>[</font><span id="dftree_root_unseen" style="color:red">' + unseen_in_shared_folders + '</span><font style=color:red>]</font>' + get_lang("My Folders")});
			else
				tree_folders.getNodeById( 'user' ).alter({caption:get_lang("Shared folders")});
			tree_folders.getNodeById( 'user' )._refresh();
		}
	}
	var display_unseen_in_mailbox = Element('dftree_root_unseen');
	if ( display_unseen_in_mailbox )
	{
		var unseen_in_mailbox = parseInt( display_unseen_in_mailbox.innerHTML );
		unseen_in_mailbox--;
		//if ( unseen_in_mailbox > 0 )
		//	tree_folders.getNodeById( 'root' ).alter({caption:'<font style=color:red>[</font><span id="dftree_root_unseen" style="color:red">' + unseen_in_mailbox + '</span><font style=color:red>]</font>' + get_lang("My Folders")});
		//else
		if(!expresso_offline)
			var node_to_refresh = 'root';
		else
			var node_to_refresh = 'local_root';
		tree_folders.getNodeById( node_to_refresh ).alter({caption:get_lang("My Folders")});
		tree_folders.getNodeById( node_to_refresh )._refresh();
	}
}

function LTrim(value){
	var w_space = String.fromCharCode(32);
	var strTemp = "";
	var iTemp = 0;

	var v_length = value ? value.length : 0;
	if(v_length < 1)
		return "";

	while(iTemp < v_length){
		if(value && value.charAt(iTemp) != w_space){
			strTemp = value.substring(iTemp,v_length);
			break;
		}
		iTemp++;
	}
	return strTemp;
}

//changes MENU background color.
function set_menu_bg(menu)
{
	menu.style.backgroundColor = 'white';
	menu.style.border = '1px solid black';
	menu.style.padding = '0px 0px';
}
//changes MENU background color.
function unset_menu_bg(menu)
{
	menu.style.backgroundColor = '';
	menu.style.border = '0px';
	menu.style.padding = '1px 0px';
}

function array_search(needle, haystack) {
	var n = haystack.length;
	for (var i=0; i<n; i++) {
		if (haystack[i]==needle) {
			return true;
		}
	}
	return false;
}

function lang_folder(fn) {
 	if (fn.toUpperCase() == "INBOX") return get_lang("Inbox");
 	if (special_folders[fn] && typeof(special_folders[fn]) == 'string') {
 		return get_lang(special_folders[fn]);
 	}
 	return fn;
}

function add_className(obj, className){
	if (obj && !exist_className(obj, className))
		obj.className = obj.className + ' ' + className;
}

function remove_className(obj, className){
	var re = new RegExp("\\s*"+className);
	if (obj)
		obj.className = obj.className.replace(re, ' ');
}

function exist_className(obj, className){
	return ( obj && obj.className.indexOf(className) != -1 )
}

function select_all_messages(select)
{
	var main = Element("tbody_box");
	var main_list = main.childNodes;
	var len_main_list = main_list.length;
	
	if (select)
	{
		for (i=0; i<len_main_list; i++)
		{
			Element("check_box_message_"+main_list[i].id).checked = true;
			add_className(Element(main_list[i].id), 'selected_msg');
		}
	}
	else
	{
		for (i=0; i<len_main_list; i++)
		{
			Element("check_box_message_"+main_list[i].id).checked = false;
			remove_className(Element(main_list[i].id), 'selected_msg');
		}
	}
}

function borkb(size){
	kbyte = 1024;
	mbyte = kbyte*1024;
	gbyte = mbyte*1024;
	if (!size)
		size = 0;
	if (size < kbyte)
		return size + ' B';
	else if (size < mbyte)
		return parseInt(size/kbyte) + ' KB';
	else if (size < gbyte)
		if (size/mbyte > 100)
			return (size/mbyte).toFixed(0) + ' MB';
		else
			return (size/mbyte).toFixed(1) + ' MB';
	else
		return (size/gbyte).toFixed(1) + ' GB';
}

function validate_date(date){
    if (date.match(/^[0-3][0-9]\/[0-1][0-9]\/\d{4,4}$/))
    {
        tmp = date.split('/');

        day = new Number(tmp[0]);
        month = new Number(tmp[1]);
        year = new Number(tmp[2]);
        if (month >= 1 && month <= 12 && day >= 1 && day <= 31)
        {
            if (month == 02 && day <= 29)
            {
                return true;
            }
            return true;
        }
        else
            {
                return false;
            }
    }
    else
        {
            return false;
        }
}
